local __FILE__=tostring(debugstack(1,2,0):match("(.*):1:")) -- MUST BE LINE 1
local _,_,_,toc=GetBuildInfo()
local pp=print
--[[
Name: ABH-Widgets.lua
Revision: $Rev: 111 $
Author: Alar of Daggerspine
Email: alar@aspide.it
Website: http://www.curse.com
SVN: $HeadUrl:$
License: GPL v2.1
--]]
local me, ns = ...
--[===[@debug@
print("Loading",__FILE__," inside ",me)
--@end-debug@]===]
if (LibDebug) then LibDebug() end
local function debug(...) 
--[===[@debug@
print(...)
--@end-debug@]===]
end
local print=_G.print
local notify=_G.print
local error=_G.error
local function dump() end
local function debugEnable() end
if (LibStub("AlarLoader-3.0",true)) then
	local rc=LibStub("AlarLoader-3.0"):GetPrintFunctions(me)
	print=rc.print
	--[===[@debug@
	debug=rc.debug
	dump=rc.dump
	--@end-debug@]===]
	notify=rc.notify
	error=rc.error
	debugEnable=rc.debugEnable
else
	debug("Missing AlarLoader-3.0")
end
debugEnable(false)
local L=LibStub("AceLocale-3.0"):GetLocale(me,true)
--[[ Standard prologue end --]]
local abh=LibStub("AceAddon-3.0"):GetAddon(me)
local AWG=LibStub("AlarWidgets-3.0")
local AceGUI=LibStub("AceGUI-3.0")
local Type,Version,Ancestor='AbhPanel',2,"AlarPanel"
if not AceGUI or (AceGUI:GetWidgetVersion(Type) or 0) >= Version then return end
local C=LibStub("AlarCore-3.0").mix.C
local InjectStandardMethods=AWG.InjectStandardMethods
local AceGUI=AWG.AceGUI
local floor=floor
local silent=true
do
	local abh=LibStub("AceAddon-3.0"):GetAddon("AlarBGHelper",silent)	
	local AceGUI=AceGUI
	local AWG=AWG
	local Serial =0
	local methods={}
	function methods:OnAcquire()
		self:Parent(Ancestor,'OnAcquire')
		self:SetScalable(true,0.6,1.5)		
	end	
	function methods:Initialize(module,bg,countdown)
		self.bg=bg
		self.module=module
		self.rows={}
		self.countdown=countdown or 62.5
		local rows=self.rows
		local status=self:Status()
		status.rows=status.rows or {}
	end
	function methods:Refresh()
		local rows=self.rows
		for _,row in pairs(rows) do row:Refresh() end
		pcall(self.SetTitle,self,GetBattlefieldInstanceRunTime())
	end
	function methods:Reset(node)
		local rows=self.rows
		if (node) then
			local row=rows[node]
			if (row) then
				--[===[@debug@
				print("Panel",node)			
				--@end-debug@]===]			
				row:Reset()
			end
		end
	end
	function methods:AddPoi(i,countdown)
		local row
		countdown=countdown or self.countdown
		local status=self:Status()
		if (not self.rows[i]) then
			row=AceGUI:Create("ABHPoiRow")
			self:AddChild(row)
			self.rows[i]=row
			row.parent=self
			row.abh=abh
		else 
			row=self.rows[i]
		end
		local status=self:Status()
		row.countdown=countdown
		row.change=tonumber(status.rows[i]) or 0
		row:SetPoi(i,countdown)
		row:Show()
		row:SetFullWidth(true)
		return row
	end

	local function Constructor()
		local self=AceGUI:Create(Ancestor)
		self.rows={}
		InjectStandardMethods(self)
		self:Inject(methods,Ancestor)			
		self.abh=abh
		self.type=Type
		return self
	end
	AceGUI:RegisterWidgetType(Type,Constructor,Version)
end	



